// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

#include <Ice/Ice.h>
#include <HelloServiceI.h>
#include <HelloI.h>
#include <HelloMgrI.h>

using namespace std;

extern "C"
{

//
// Factory function
//
ICE_DECLSPEC_EXPORT IceBox::Service*
create(Ice::CommunicatorPtr communicator)
{
    return new HelloServiceI;
}

}

HelloServiceI::HelloServiceI()
{
}

HelloServiceI::~HelloServiceI()
{
}

void
HelloServiceI::start(const string& name, const Ice::CommunicatorPtr& communicator, const Ice::StringSeq& args)
{
    _adapter = communicator->createObjectAdapter(name);
    Demo::HelloPtr hello = new HelloI;
    _adapter->add(hello, communicator->stringToIdentity("hello"));
    _adapter->activate();

    string nameMrg = name + "Mgr";
    _adapterMgr = communicator->createObjectAdapter(nameMrg);
    Demo::HelloMgrPtr helloMgr = new HelloMgrI;
    _adapterMgr->add(helloMgr, communicator->stringToIdentity("helloMgr"));
    _adapterMgr->activate();

    std::cout << "Hello adapter: " << name << std::endl;
    std::cout << "HelloMgr adapter: " << nameMrg << std::endl;
}

void
HelloServiceI::stop()
{
    _adapter->destroy();
    _adapterMgr->destroy();
}
